package controler;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

import model.ToDo;
import model.ToDoList;
import model.FileType;
import view.AboutDialog;
import view.ToDoListFrame;

public class Controler
extends WindowAdapter
{
	private ToDoListFrame frame;
	private ToDoList lst;
	public Controler() {
		frame = null;
		lst = null;
  	}
	public void setView(ToDoListFrame f) {
		frame = f;
	}
	public void setModel(ToDoList l) {
		lst = l;
	}
	public void about() {
		(AboutDialog.getInstance()).display();
	}
	public void newToDo() {
		try {
			ToDo alarm = new ToDo();
			lst.add(alarm);
		} catch(Exception e) { };
		lst.sort();
		frame.updateToDoList();
		frame.disableEditor();
		lst.setChanged();
        frame.updateTitle();
	}
	public void loadToDo() {
        JFileChooser fileChooser = new JFileChooser();
        FileType ft = FileType.BINARY;
        FileNameExtensionFilter filter = new FileNameExtensionFilter(ft.legend(), ft.extension());
        fileChooser.setFileFilter(filter);
        switch (fileChooser.showOpenDialog(frame)) {
            case JFileChooser.CANCEL_OPTION  :
                break;
            case JFileChooser.APPROVE_OPTION :
                if (lst.load(fileChooser.getSelectedFile())) {
            		frame.updateToDoList();
            		frame.disableEditor();
                    frame.updateTitle();
                    frame.allowSaveItem(true);
                } else
                    JOptionPane.showMessageDialog(frame,
                                                  "Un problème est survenu pendant la lecture du fichier.",
                                                  "Choses à faire non chargées",
                                                  JOptionPane.ERROR_MESSAGE);
                break;
            case JFileChooser.ERROR_OPTION   :
                JOptionPane.showMessageDialog(frame,
                                              "Un problème est survenu lors du choix de fichier.",
                                              "Choses à faire non chargées",
                                              JOptionPane.ERROR_MESSAGE);
                break;
        }
	}
	public void saveToDo() {
        if (!lst.save()) {
            JOptionPane.showMessageDialog(frame,
                                          "Un problème est survenu pendant l'enregistrement du pense-bête.",
                                          "Choses à faire non enregistrées",
                                          JOptionPane.ERROR_MESSAGE);
        } else {
            frame.updateTitle();
        }
	}
	private File fileChoosedWithExtension(File file, FileNameExtensionFilter filter) {
		String[] extensions = filter.getExtensions();
		String fileName = file.getName().toLowerCase();
		if (fileName.endsWith('.' + extensions[0])) return file;
		file = new File(file.getAbsolutePath() + '.' + extensions[0]);
		return file;
	}
	public void saveToDoAs() {
        JFileChooser fileChooser = new JFileChooser();
        for(FileType ft : FileType.values()) {
            fileChooser.addChoosableFileFilter(new FileNameExtensionFilter(ft.legend(), ft.extension()));
        }
        fileChooser.setAcceptAllFileFilterUsed(false);
        switch (fileChooser.showSaveDialog(frame)) {
            case JFileChooser.CANCEL_OPTION  :
                break;
            case JFileChooser.APPROVE_OPTION :
                if (lst.saveAs(fileChoosedWithExtension(fileChooser.getSelectedFile(), (FileNameExtensionFilter)fileChooser.getFileFilter()))) {
                	frame.updateTitle();
                } else {
                    JOptionPane.showMessageDialog(frame,
                                                  "Un problème est survenu pendant l'enregistrement du pense-bête.",
                                                  "Choses à faire non enregistrées",
                                                  JOptionPane.ERROR_MESSAGE);
                }
                break;
            case JFileChooser.ERROR_OPTION   :
                JOptionPane.showMessageDialog(frame,
                                              "Un problème est survenu lors du choix de fichier pour l'enregistrement du pense-bête.",
                                              "Choses à faire non enregistrées",
                                              JOptionPane.ERROR_MESSAGE);
                break;
        }
	}
	public void changeToDo(ToDo toDo, String name, String dueTo, boolean done) {
		toDo.name(name);
		toDo.setDone(done);
		try { toDo.dueDate(dueTo); } catch(Exception e) { }
		lst.sort();
		lst.setChanged();
		frame.updateToDoList();
		frame.disableEditor();
		frame.updateTitle();
	}
	public void removeToDo(ToDo t) {
		lst.remove(t);
		lst.setChanged();
		frame.updateToDoList();
		frame.disableEditor();
		frame.updateTitle();
	}
	public void quit() {
    	Object[] options = { "Oui", "Non" };
        if (lst.hasChanged()) {
            switch(JOptionPane.showOptionDialog(frame,
            		                            "Des modifications ont été apportées à la liste des choses à faire !\nVoulez-vous quitter sans enregistrer ?",
            		                            "Quitter Pense-bête",
            		                            JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
            		                            null, options, options[1]
        									 )) {
            case JOptionPane.YES_OPTION : break;
            default                     : return;
            }
        }
        System.exit(0);
	}
    public void windowClosing(WindowEvent e) {
    	quit();
    }
}
