package model;

public enum FileType {
	BINARY ("Choses à faire au format binaire", "td"),
	TEXT ("Alarmes au format texte", "txt");

	public final String extension;
	public final String legend;

	private FileType(String leg, String ext) {
		legend = leg;
		extension = ext;
	}
	public String extension() { return extension; }
	public String legend() { return legend; }
	public String toString() { return name() + "(" + extension + ")"; }
	public static FileType typeForExtension(String ext) {
		for (FileType ft : FileType.values()) {
			if (ext.equals(ft.extension())) return ft;
		}
		return null;
	}
}
