package model;

import java.io.DataOutputStream;

import app.PenseBete;

public class SaveBinary implements Operation {
	private DataOutputStream s;
	public SaveBinary(DataOutputStream s) {
		this.s = s;
	}
	public void doItOn(ToDoList l) throws Exception {
		s.writeByte(PenseBete.FILE_VERSION);
		s.writeInt(l.size());
		for(ToDo a : l) { doItOn(a); }
	}
	public void doItOn(ToDo t) throws Exception {
		s.writeUTF(t.name());
		s.writeBoolean(t.isDone());
		doItOn(t.dueDate());
	}
	public void doItOn(Date d) throws Exception {
		s.writeInt((byte)(d.year()));
		s.writeByte((byte)(d.month()));
		s.writeByte((byte)(d.day()));
	}
}
