package model;

import java.io.PrintWriter;

public class SaveText implements Operation {
	private PrintWriter w;
	public SaveText(PrintWriter w) {
		this.w = w;
	}
	public void doItOn(ToDoList l) throws Exception {
		for(ToDo t : l) { doItOn(t); }
	}
	public void doItOn(ToDo t) throws Exception {
		w.print(t.name());
		w.print('\t');
		w.print((t.isDone()) ? "fait" : "à faire");
		if (t.dueDate().day() != 0) {
			w.print("\téchéance : ");
			doItOn(t.dueDate());
		}
		w.println();
	}
	public void doItOn(Date d) throws Exception {
		w.print(d);
	}
}
