package model;

public class ToDo implements Comparable<ToDo>, Operable {
	private String name;
	private Date dueTo;
	private boolean done;
    public ToDo() {
    	name = "sans nom";
    	dueTo = null;
    	done = false;
    }
    public String name() {
        return name;
	}
	public void name(String name) {
		this.name = name;
	}
	public Date dueDate() {
		return dueTo;
	}
	public void dueDate(String date)
    throws Exception {
		if (date.equals(""))
			dueTo = null;
		else
			dueTo = new Date(date);
	}
	public void dueDate(Date d)
    throws Exception {
		if (d.day() == 0)
			dueTo = null;
		else
			dueTo = d;
	}
	public void setDone(boolean b) {
		done = b;
	}
	public boolean isDone() {
		return done;
	}
	public String toString() {
		String s = name;
		if (dueTo != null) s += " (pour le " + dueTo + ")";
		s += " : " + ((done) ? "fait" : "à faire");
		return s;
	}
	public int compareTo(ToDo o) {
		return name.compareTo(o.name);
	}
	public void performs(Operation op) throws Exception {
		op.doItOn(this);
	}
}
